/***********************************************
 *                                             *
 *              CS520 Fall 2006                *
 *           Programming Assignment            *
 *         Computer Science Department         *
 *             Boston University               *
 *                                             *
 ***********************************************/

/* Yacc grammar for the parser. */

%{
open Support.Error
open Support.Pervasive
open Syntax
%}

/* Keyword tokens */
%token <Support.Error.info> LAMBDA
%token <string Support.Error.withinfo> VAR
%token EOF

/* Symbolic tokens */
%token <Support.Error.info> DARROW
%token <Support.Error.info> LPAREN
%token <Support.Error.info> RPAREN


%type < Syntax.term0 > toplevel

%start toplevel

%%

/* Main body of the parser definition */
   
toplevel: term EOF                             { $1 }
;

term :
    apptm                                      { $1 }
  | LAMBDA LPAREN VAR RPAREN DARROW term       { TmLam0 ($3.v, $6) } /* lambda abstraction*/

/* application */
apptm : 
    atm                                        { $1 }
  | apptm atm                                  { TmApp0 ($1, $2) }

/* Atomic terms are ones that never require extra parentheses */
atm :
    LPAREN term RPAREN                         { $2 }
  | VAR                                        { TmVar0 ($1.v) }
















